Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing.undo
Class StateEdit

    java.lang.Object
      |
      +--javax.swing.undo.AbstractUndoableEdit
            |
            +--javax.swing.undo.StateEdit

public class StateEdit
extends AbstractUndoableEdit

StateEdit is a general edit for objects that change state. Objects being edited must conform to the StateEditable interface.

This edit class works by asking an object to store it's state in Hashtables before and after editing occurs. Upon undo or redo the object is told to restore it's state from these Hashtables.

A state edit is used as follows:

    	// Create the edit during the "before" state of the object
    	StateEdit newEdit = new StateEdit(myObject);
    	// Modify the object
    	myObject.someStateModifyingMethod();
    	// "end" the edit when you are done modifying the object
    	newEdit.end();

Note that when a StateEdit ends, it removes redundant state from the Hashtables - A state Hashtable is not guaranteed to contain all keys/values placed into it when the state is stored!

See Also:
  `StateEditable`, Serialized Form

Field Summary
`protected StateEditable` | `object` The object being edited
`protected java.util.Hashtable` | `postState` The state information after the edit
`protected java.util.Hashtable` | `preState` The state information prior to the edit
`protected static java.lang.String` | `RCSID`
`protected java.lang.String` | `undoRedoName` The undo/redo presentation name

Fields inherited from class javax.swing.undo.AbstractUndoableEdit
`RedoName, UndoName`

Constructor Summary
`StateEdit(StateEditable anObject)` Create and return a new StateEdit.
`StateEdit(StateEditable anObject, java.lang.String name)` Create and return a new StateEdit with a presentation name.

Method Summary
`void` | `end()` Gets the post-edit state of the StateEditable object and ends the edit.
`java.lang.String` | `getPresentationName()` Gets the presentation name for this edit
`protected void` | `init(StateEditable anObject, java.lang.String name)`
`void` | `redo()` Tells the edited object to apply the state after the edit
`protected void` | `removeRedundantState()` Remove redundant key/values in state hashtables.
`void` | `undo()` Tells the edited object to apply the state prior to the edit

Methods inherited from class javax.swing.undo.AbstractUndoableEdit
`addEdit, canRedo, canUndo, die, getRedoPresentationName, getUndoPresentationName, isSignificant, replaceEdit, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### RCSID

    protected static final java.lang.String RCSID

### object

    protected StateEditable object

  The object being edited

### preState

    protected java.util.Hashtable preState

  The state information prior to the edit

### postState

    protected java.util.Hashtable postState

  The state information after the edit

### undoRedoName

    protected java.lang.String undoRedoName

  The undo/redo presentation name

Constructor Detail

### StateEdit

    public StateEdit(StateEditable anObject)

  Create and return a new StateEdit.
  Parameters:
    `anObject` - The object to watch for changing state
  See Also:
    `StateEdit`

### StateEdit

    public StateEdit(StateEditable anObject,
                     java.lang.String name)

  Create and return a new StateEdit with a presentation name.
  Parameters:
    `anObject` - The object to watch for changing state
    `name` - The presentation name to be used for this edit
  See Also:
    `StateEdit`

Method Detail

### init

    protected void init(StateEditable anObject,
                        java.lang.String name)

### end

    public void end()

  Gets the post-edit state of the StateEditable object and ends the edit.

### undo

    public void undo()

  Tells the edited object to apply the state prior to the edit
  Overrides:
    undo in class AbstractUndoableEdit

### redo

    public void redo()

  Tells the edited object to apply the state after the edit
  Overrides:
    redo in class AbstractUndoableEdit

### getPresentationName

    public java.lang.String getPresentationName()

  Gets the presentation name for this edit
  Overrides:
    getPresentationName in class AbstractUndoableEdit

### removeRedundantState

    protected void removeRedundantState()

  Remove redundant key/values in state hashtables.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-1998 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.